﻿using System;

namespace EsempioVisitor
{
    public interface Visitor
    {
        void Visit(Red red);
        void Visit(Blu blu);
    }

    public class CallingVisitor : Visitor
    {
        public void Visit(Red red)
        {
            red.Eye();
        }

        public void Visit(Blu blu)
        {
            blu.Sky();
        }
    }

    public class CountingVisitor : Visitor
    {
        private int _numRed = 0;
        private int _numBlu = 0;

        public void Visit(Red red)
        {
            _numRed++;
        }

        public void Visit(Blu blu)
        {
            _numBlu++;
        }

        public override string ToString()
        {
            return String.Format("Reds {0}, Blus {1}", _numRed, _numBlu);
        }
    }
}
